﻿// =================================================================================================
// Copyright © Quorum Business Solutions, Inc. 2008-2014.  All Rights Reserved.
// =================================================================================================

#region Using Statements
using System.ComponentModel;
#endregion

namespace GridRowDelete.Data
{
    public class QTRMBindingList<T> : BindingList<T>
    {
        // Add "Removing" event
        public delegate void QTRMListChangedEventHandler(object sender, QTRMListChangedEventArgs e);
        public event QTRMListChangedEventHandler Removing;

        protected void OnRemoving(QTRMListChangedEventArgs e)
        {
            if (Removing != null)
            {
                Removing(this, e);
            }
        }

        protected override void RemoveItem(int index)
        {
            if (index > -1 && index < this.Count)
            {
                // Raise "Removing" event
                QTRMListChangedEventArgs args = new QTRMListChangedEventArgs(ListChangedType.ItemDeleted, index);
                OnRemoving(args);

                // Only proceed if not cancelled
                if (!args.Cancel)
                {
                    base.RemoveItem(index);
                }
            }
        }
    }
}
