﻿// =================================================================================================
// Copyright © Quorum Business Solutions, Inc. 2008-2014.  All Rights Reserved.
// =================================================================================================

#region Using Statements
using System.ComponentModel;
#endregion

namespace GridRowDelete.Data
{
    public class QTRMListChangedEventArgs : ListChangedEventArgs
    {
        // Add Cancel attribute to provide a mechanism for canceling an operation.
        public bool Cancel { get; set; }

        public QTRMListChangedEventArgs(ListChangedType listChangedType, int newIndex)
            : base(listChangedType, newIndex)
        {
            this.Cancel = false;
        }

        public QTRMListChangedEventArgs(ListChangedType listChangedType, PropertyDescriptor propDesc)
            : base(listChangedType, propDesc)
        {
            this.Cancel = false;
        }

        public QTRMListChangedEventArgs(ListChangedType listChangedType, int newIndex, int oldIndex)
            : base(listChangedType, newIndex, oldIndex)
        {
            this.Cancel = false;
        }

        public QTRMListChangedEventArgs(ListChangedType listChangedType, int newIndex, PropertyDescriptor propDesc)
            : base(listChangedType, newIndex, propDesc)
        {
            this.Cancel = false;
        }
    }
}
