﻿
#region Using Statements
using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;

using GridRowDelete.Data;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Data;
using System.Windows.Threading;
using System.ComponentModel;
using GridRowDelete.CustomizationLogic;
#endregion

namespace GridRowDelete
{
    
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private readonly string m_AppTitle = "Grid Row Delete Example";

        //private ColTopMovie m_Data = null;

        private ObservableCollection<TopMovie> m_Data2 = new ObservableCollection<TopMovie>();

        
        private TopMovieData m_DataAdo;

        public event PropertyChangedEventHandler PropertyChanged;

        public DataView DataForBinding
        { get { return m_DataAdo.Group.DefaultView; } } 


        /// <summary>
        /// Kill these
        /// </summary>
        private void xamDataPresenter1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e) {}
        private void xamDataPresenter1_AssigningFieldLayoutToItemDirect(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e) {}
        private void xamDataPresenter1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e) { }
        private void xamDataPresenter1_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e) {}



        public MainWindow()
        {
            try
            {
            m_DataAdo = new TopMovieData();
                InitializeComponent();

                LoadData();



            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, m_AppTitle, MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void LoadButtonOnClick(object sender, RoutedEventArgs e)
        {


            using (var LogicObj = new DataGridColumnLogic())
            {
                var CurrentCustomizations = LogicObj.GetCurrentBatchCustomizations(m_DataGrid, p_GetGenericEquivalent: true);
            }

            //try
            //{
            //    LoadData();
            //    BindData();
            //}
            //catch (Exception ex)
            //{
            //    MessageBox.Show(ex.Message, m_AppTitle, MessageBoxButton.OK, MessageBoxImage.Error);
            //}
        }

        private void RebindButtonOnClick(object sender, RoutedEventArgs e)
        {
            //try
            //{
            //    BindData();
            //}
            //catch (Exception ex)
            //{
            //    MessageBox.Show(ex.Message, m_AppTitle, MessageBoxButton.OK, MessageBoxImage.Error);
            //}
        }

        private void LoadData()
        {
            

            
            //m_Data2 = new ColTopMovie();
            m_Data2.Add(new TopMovie("Open Season", "1 hr. 40 min.", DateTime.Parse("September 29, 2006"), "PG", "C", 23624548M));
            m_Data2.Add(new TopMovie("The Guardian", "2 hrs. 19 min.", DateTime.Parse("September 29, 2006"), "PG-13", "C", 18006064M));
            m_Data2.Add(new TopMovie("School For Scoundrels", "1 hr. 41 min.", DateTime.Parse("September 29, 2006"), "PG-13", "C-", 8602333M));
            m_Data2.Add(new TopMovie("Jet Li's Fearless", "1 hr. 43 min.", DateTime.Parse("September 22, 2006"), "PG-13", "B-", 18066869M));
            m_Data2.Add(new TopMovie("Gridiron Gang", "120 min.", DateTime.Parse("September 15, 2006"), "PG-13", "C+", 33258307M));
            m_Data2.Add(new TopMovie("The Illusionist", "1 hr. 49 min.", DateTime.Parse("August 18, 2006 "), "PG-13", "B", 31378443M));
            m_Data2.Add(new TopMovie("Flyboys", "2 hrs. 9 min.", DateTime.Parse("September 22, 2006"), "PG-13", "C", 9946969M));
            m_Data2.Add(new TopMovie("The Black Dahlia", "2 hrs. 1 min.", DateTime.Parse("September 15, 2006 "), "R", "C", 20742610M));
            m_Data2.Add(new TopMovie("Little Miss Sunshine", "1 hr. 41 min.", DateTime.Parse("July 26, 2006 "), "R", "B+", 53133641M));
            m_Data2.Add(new TopMovie("Facing the Giants", "1 hr. 51 min.", DateTime.Parse("September 29, 2006"), "PG", "", 1343537M));
            m_Data2.Add(new TopMovie("The Covenant", "1 hr. 37 min.", DateTime.Parse("September 8, 2006"), "PG-13", "", 22265370M));
            m_Data2.Add(new TopMovie("The Last Kiss", "1 hr. 43 min.", DateTime.Parse("September 15, 2006"), "R", "C+", 10420006M));
            m_Data2.Add(new TopMovie("Everyone's Hero", "1 hr. 26 min.", DateTime.Parse("September 15, 2006"), "G", "C+", 13307759M));
            m_Data2.Add(new TopMovie("The Science of Sleep", "1 hr. 46 min.", DateTime.Parse("September 22, 2006"), "R", "B-", 1616252M));
            m_Data2.Add(new TopMovie("Invincible", "1 hr. 48 min.", DateTime.Parse("August 25, 2006"), "PG", "B-", 56322748M));
            m_Data2.Add(new TopMovie("Hollywoodland", "126 min", DateTime.Parse("September 8, 2006"), "R", "B-", 13939745M));
            m_Data2.Add(new TopMovie("Talladega Nights: The Ballad of Ricky Bobby", "1 hr. 50 min.", DateTime.Parse("August 4, 2006"), "PG-13", "B", 147421245M));
            m_Data2.Add(new TopMovie("Pirates of the Caribbean: Dead Man's Chest", "145 min.", DateTime.Parse("July 7, 2006"), "PG-13", "B-", 420331126M));



            foreach (string StrRating in m_Data2.Select(p => p.MPAARating).Where(p => p =="PG").Distinct())
            {
                var RowGroup = m_DataAdo.Group.AddGroupRow(
                    StrRating);

                m_Data2.ToList().ForEach(p =>
                {
                    m_DataAdo.TopMovie.AddTopMovieRow(

                        p.Title,
                        p.RunningTime,
                        p.ReleaseDate,
                        p.MPAARating,
                        p.CriticsRating,
                        p.CumGross,
                        RowGroup,
                        MovableFieldA: string.Empty,
                        MovableFieldB: string.Empty,
                        MovableFieldC: string.Empty);
                } );

                m_Data2.ToList().ForEach(p =>
                {
                    m_DataAdo.OtherMovie.AddOtherMovieRow(

                        p.Title,
                        p.RunningTime,
                        p.ReleaseDate,
                        p.MPAARating,
                        p.CriticsRating,
                        p.CumGross,
                        RowGroup,
                        MovableFieldA: string.Empty,
                        MovableFieldB: string.Empty,
                        MovableFieldC: string.Empty);

                } );


                    }


            PropertyChanged.Invoke(this, new PropertyChangedEventArgs("DataForBinding"));


        }

        private void BindData()
        {
                        


        }

        private void DataGrid_PreviewKeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
                                                                                          
        }


        /// <summary>
        /// No prompt no cancel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DataGrid_RecordsDeleting(object sender, Infragistics.Windows.DataPresenter.Events.RecordsDeletingEventArgs e)
        {

        }

        private void ThisWindow_Loaded(object sender, RoutedEventArgs e)
        {
            //MakeCustomizations();
        }

        private void MakeCustomizations()
        {
            using (var LogicObj = new DataGridColumnLogic())
            {
                var CurrentCustomizations = LogicObj.GetCurrentBatchCustomizations(m_DataGrid, p_GetGenericEquivalent: true);

                CurrentCustomizations = LogicObj.MakeHidden("MovableFieldC", CurrentCustomizations);
                CurrentCustomizations = LogicObj.MoveColumn("MovableFieldA", 7, CurrentCustomizations);
                CurrentCustomizations = LogicObj.MoveColumn("MovableFieldB", 6, CurrentCustomizations);

                LogicObj.LoadCustomizations(m_DataGrid, "TopMovieFieldLayout", "GroupTopMovie", CurrentCustomizations);
                LogicObj.LoadCustomizations(m_DataGrid, "OtherMovieFieldLayout", "GroupOtherMovie", CurrentCustomizations);

            }
        }

        private void m_DataGrid_Loaded(object p_Sender, RoutedEventArgs p_Args)  
        {
             (p_Sender as XamDataGrid).Records.ExpandAll(recursive: true);

 

            Dispatcher.BeginInvoke(new Action(() => {  MakeCustomizations(); }), DispatcherPriority.ContextIdle);
        }  

    }
}
